您的位置:首页 > 其它

HDU 1524 - A Chess Game(SG)

2014-09-16 09:34 316 查看

A Chess Game

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 1407 Accepted Submission(s): 639



[align=left]Problem Description[/align]
Let's design a new chess game. There are N positions to hold M chesses in this game. Multiple chesses can be located in the same position. The positions are constituted as a topological graph, i.e. there are directed edges connecting
some positions, and no cycle exists. Two players you and I move chesses alternately. In each turn the player should move only one chess from the current position to one of its out-positions along an edge. The game does not end, until one of the players cannot
move chess any more. If you cannot move any chess in your turn, you lose. Otherwise, if the misfortune falls on me... I will disturb the chesses and play it again.

Do you want to challenge me? Just write your program to show your qualification!

[align=left]Input[/align]
Input contains multiple test cases. Each test case starts with a number N (1 <= N <= 1000) in one line. Then the following N lines describe the out-positions of each position. Each line starts with an integer Xi that is the number
of out-positions for the position i. Then Xi integers following specify the out-positions. Positions are indexed from 0 to N-1. Then multiple queries follow. Each query occupies only one line. The line starts with a number M (1 <= M <= 10), and then come M
integers, which are the initial positions of chesses. A line with number 0 ends the test case.

[align=left]Output[/align]
There is one line for each query, which contains a string "WIN" or "LOSE". "WIN" means that the player taking the first turn can win the game according to a clever strategy; otherwise "LOSE" should be printed.

[align=left]Sample Input[/align]

4
2 1 2
0
1 3
0
1 0
2 0 2
0

4
1 1
1 2
0
0
2 0 1
2 1 1
3 0 1 3
0


[align=left]Sample Output[/align]

WIN
WIN
WIN
LOSE
WIN


[align=left]Source[/align]
PKU Monthly

==============================

题意:各点之间满足拓扑关系,有向无环图。

第一行 输入点的个数n。接下来n行 每行是第i个点能到达的 点的数量 和 具体的点。

然后是多组询问,还是个数和点,输入0结束。

好像是sg函数的基本定义……

#include <iostream>
#include <cstdio>
#include <cstring>
#include <vector>

using namespace std;
const int maxn=1005;
vector<int>v[maxn];
int n,x,u,q,m;
int sg[maxn];

int dfs(int x){
if(sg[x]!=-1) return sg[x];
if(v[x].size()==0) return sg[x]=0;
bool vis[maxn];
memset(vis,0,sizeof(vis));
for(int i=0;i<v[x].size();i++){
vis[dfs(v[x][i])]=1;
}
for(int i=0;;i++){
if(!vis[i]) return sg[x]=i;
}
}

int main()
{
while(~scanf("%d",&n)){
memset(sg,-1,sizeof(sg));
//sg[0]=0; 注意这里不用这句初始化,因为点之间满足拓扑关系所以没有后继的点sg为0
for(int i=0;i<n;i++){
v[i].clear();
scanf("%d",&x);
while(x--){
scanf("%d",&u);
v[i].push_back(u);
}
}
while(~scanf("%d",&q)){
if(q==0) break;
int ans=0;
while(q--){
scanf("%d",&u);
ans^=dfs(u);
}
if(ans==0) printf("LOSE\n");
else printf("WIN\n");
}
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: